<?php

/**
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license. If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Safety
 * @package    QT-registrations
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.2 build:20090710
 * @link       http://www.qt-cute/doc/package/qtg
 * @since      File available since Release 1.0.0
 * @deprecated File deprecated in Release 3.0.0
 */

session_start();
require_once('bin/qtr_init.php');
include(Translate('qtr_adm.php'));
include(Translate('qtrm_export_xml.php'));
if ( $oVIP->role!='A' ) die(Error(13));

// INITIALISE

$intTopics = 0;
$arrYears = array(
  strval(date('Y'))=>strval(date('Y')),
  strval(date('Y')-1)=>strval(date('Y')-1),
  'old'=>'&lt; '.strval(date('Y')-1)
  );

if ( !isset($_SESSION['m_export_xml']) )
{
  $_SESSION['m_export_xml'] = array(
  'title'   => 'export_'.date('Ymd').'.xml',
  'dropbbc' => 'Y');
}

$oVIP->selfurl = 'qtrm_export_xml_adm.php';
$oVIP->selfname = $L['export_xml']['Admin'];
$oVIP->exiturl = $oVIP->selfurl;
$oVIP->exitname = $oVIP->selfname;
$strPageversion = $L['export_xml']['Version'].' 2.2';

// --------
// SUBMITTED
// --------

if ( isset($_POST['submit']) )
{
  // read and check mandatory
  if ( isset($_POST['dropbbc']) ) { $_SESSION['m_export_xml']['dropbbc']='Y'; } else { $_SESSION['m_export_xml']['dropbbc']='N'; }
  if ( empty($_POST['title']) ) $error='Filename '.Error(1);
  if ( substr($_POST['title'],-4,4)!='.xml' ) $_POST['title'] .= '.xml';

  // EXPORT COUNT
  if ( empty($error) )
  {
    // query
    $strWhere = ' WHERE ';
    if ( $_POST['section']!='*' ) { $strWhere .= ' section='.$_POST['section']; } else { $strWhere .= 'section>=0'; }
    if ( $_POST['year']!='*' )
    {
      if ( $_POST['year']=='old' ) { $strOp='<'; $_POST['year']=strval(Date('Y')-1); } else { $strOp='='; }
      switch(substr($oDB->type,0,5))
      {
      case 'mysql': $strWhere .= ' AND LEFT(firstpostdate,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'mssql': $strWhere .= ' AND LEFT(firstpostdate,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'pg':    $strWhere .= ' AND SUBSTRING(firstpostdate,1,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'ibase': $strWhere .= ' AND SUBSTRING(firstpostdate FROM 1 FOR 4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'sqlit': $strWhere .= ' AND SUBSTR(firstpostdate,1,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'acces': $strWhere .= ' AND LEFT(firstpostdate,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'db2':   $strWhere .= ' AND SUBSTR(firstpostdate,1,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      case 'oci':   $strWhere .= ' AND SUBSTR(firstpostdate,1,4)'.$strOp.'"'.$_POST['year'].'"'; break;
      default: die('Unknown db type '.$oDB->type);
      }
    }

    // count
    $strQ = 'SELECT count(*) as countid FROM '.TABTOPIC.$strWhere;
    $oDB->Query($strQ);
    $row=$oDB->Getrow();
    $intTopics = $row['countid'];
    if ( $intTopics ==0 ) $error='No data found';
  }

  // ------
  // EXPORT XML
  // ------

  if ( empty($error) )
  {
    $oDB2 = new cDB($qtr_dbsystem,$qtr_host,$qtr_database,$qtr_user,$qtr_pwd,$qtr_port,$qtr_dsn);
  
    // start export
    
    if (!headers_sent())
    {
      header('Content-Type: text/xml; charset='.QTR_HTML_CHAR);
      header('Content-Disposition: attachment; filename="'.$_POST['title'].'"');
    }

    echo '<?xml version="1.0"?>',N;
    echo '<qtregistrations version="2.2">',N;
      
    // export topic
    $oDB->Query( 'SELECT * FROM '.TABTOPIC.$strWhere );
    while($row=$oDB->Getrow()) 
    {
      $oTopic = new cTopic($row);
      
      echo '<topic id="',$oTopic->id,'" type="',$oTopic->type,'" section="',$oTopic->section,'">',N;
      echo '<numid>',$oTopic->numid,'</numid>',N;
      echo '<status>',$oTopic->status,'</status>',N;
      if ( !empty($oTopic->statusdate) )    echo '<statusdate>',$oTopic->statusdate,'</statusdate>',N;
      if ( !empty($oTopic->eventdate) )     echo '<eventdate>',$oTopic->eventdate,'</eventdate>',N;
      if ( !empty($oTopic->wisheddate) )    echo '<wisheddate>',$oTopic->wisheddate,'</wisheddate>',N;
      if ( !empty($oTopic->firstpostid) )   echo '<firstpostid>',$oTopic->firstpostid,'</firstpostid>',N;
      if ( !empty($oTopic->lastpostid) )    echo '<lastpostid>',$oTopic->lastpostid,'</lastpostid>',N;
      if ( !empty($oTopic->firstpostuser) ) echo '<firstpostuser>',$oTopic->firstpostuser,'</firstpostuser>',N;
      if ( !empty($oTopic->lastpostuser) )  echo '<lastpostuser>',$oTopic->lastpostuser,'</lastpostuser>',N;
      if ( !empty($oTopic->firstpostname) ) echo '<firstpostname>',$oTopic->firstpostname,'</firstpostname>',N;
      if ( !empty($oTopic->lastpostname) )  echo '<lastpostname>',$oTopic->lastpostname,'</lastpostname>',N;
      if ( !empty($oTopic->firstpostdate) ) echo '<firstpostdate>',$oTopic->firstpostdate,'</firstpostdate>',N;
      if ( !empty($oTopic->lastpostdate) )  echo '<lastpostdate>',$oTopic->lastpostdate,'</lastpostdate>',N;
      if ( !empty($oTopic->x) )             echo '<x>',$oTopic->x,'</x>',N;
      if ( !empty($oTopic->y) )             echo '<y>',$oTopic->y,'</y>',N;
      if ( !empty($oTopic->z) )             echo '<z>',$oTopic->z,'</z>',N;
      if ( !empty($oTopic->tags) )          echo '<tags>',$oTopic->tags,'</tags>',N;
      
      echo '<posts>',N;
        
        $oDB2->Query( 'SELECT * FROM '.TABPOST.' WHERE topic='.$oTopic->id );
        while($row2=$oDB2->Getrow()) 
        {
          $oPost = new cPost($row2);
          echo '<post id="',$oPost->id,'" type="',$oPost->type,'">',N;
          echo '<icon>',$oPost->icon,'</icon>',N;
          echo '<title>',$oPost->title,'</title>',N;
          echo '<userid>',$oPost->userid,'</userid>',N;
          echo '<username>',$oPost->username,'</username>',N;
          echo '<issuedate>',$oPost->issuedate,'</issuedate>',N;
          if ( !empty($oPost->modifdate) ) echo '<modifdate>',$oPost->modifdate,'</modifdate>',N;
          if ( !empty($oPost->modifuser) ) echo '<modifuser>',$oPost->modifuser,'</modifuser>',N;
          if ( !empty($oPost->modifname) ) echo '<modifname>',$oPost->modifname,'</modifname>',N;
          echo '<textmsg>',$oPost->text,'</textmsg>',N;          
          echo '</post>',N;          
        }

      echo '</posts>',N;
      
      echo '<datas>',N;
        
        $oDB2->Query( 'SELECT tabid,fieldid,fieldvalue FROM '.TABDATA.' WHERE id='.$oTopic->id );
        while($row2=$oDB2->Getrow()) 
        {
          if ( is_string($row2['fieldvalue']) ) {
          if ( $row2['fieldvalue']!='' ) {
            echo '<data id="',$row2['fieldid'],'" type="',$row2['tabid'],'">',$row2['fieldvalue'],'</data>',N;
          }}
        }

      echo '</datas>',N;

      echo '<docs>',N;
        
        $oDB2->Query( 'SELECT * FROM '.TABDOC.' WHERE id='.$oTopic->id );
        while($row2=$oDB2->Getrow()) 
        {
          echo '<doc id="',$row2['docfile'],'">',N;
          foreach ($row2 as $strKey=>$strValue )
          {
          if ( $strKey!='id' ) echo '<',$strKey,'>',$strValue,'</',$strKey,'>',N;
          }
          echo '</doc>',N;
        }

      echo '</docs>',N;

      echo '</topic>',N;
    }
    
    // end export

    echo '</qtregistrations>';
    exit;
  }

}

// --------
// HTML START
// --------

$strHeadScript = '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert("'.$L['Missing'].': File"); return false; }
  return null;
}
-->
</script>
';

include('qtr_adm_p_header.php');
include('qtr_adm_p_title.php');

echo '<form method="post" action="',$oVIP->selfurl,'" onsubmit="return ValidateForm(this);">
<table class="data_o" cellspacing="0">
<tr class="data_o">
<td class="th_o th_o_all" colspan="3">',$L['export_xml']['Content'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="section">',$L['Section'],'</label></td>
<td class="td_o" colspan="2">
<select id="section" name="section" size="1">
<option value="*">',$L['All'],'</option>
<option value="-" disabled="disabled">----------</option>
',QTasOption(GetSectionTitles('A')),'
</select>
</td>
</tr>
';
echo '<tr class="data_o">';
echo '<td class="th_o th_o_first">',$L['Topics'],'</td>';
echo '<td class="td_o"><select name="year" size="1">
<option value="*">',$L['All'],'</option>
<option value="-" disabled="disabled">----------</option>
';
foreach ($arrYears as $intKey => $strValue)
{
echo '<option value="',$intKey,'">',$strValue,'</option>';
}
echo '</select></td>
<td class="td_o"><span class="help">&nbsp;</span></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first">',$L['export_xml']['Drop_bbc'],'</td>
<td class="td_o" colspan="2"><input type="checkbox" id="dropbbc" name="dropbbc"',($_SESSION['m_export_xml']['dropbbc']=='Y' ? QCHE : ''),'/> <label for="dropbbc">',$L['export_xml']['H_Drop_bbc'],'</label></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="3">',$L['Destination'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="title">',$L['export_xml']['Filename'],'</label></td>
<td class="td_o" colspan="2"><input type="text" id="title" name="title" size="32" maxlength="32" value="',$_SESSION['m_export_xml']['title'],'"/></td>
</tr>';
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="3" style="padding:6px; text-align:center"><input type="submit" name="submit" value="',$L['Ok'],'"/></td>
</tr>
';
echo '</table>
</form>
';

// HTML END

include('qtr_adm_p_footer.php');

?>